import java.io.*;
import java.util.*;
import java.math.*;

public class firtree_ab implements Runnable {

	final int MINK = 2;
	final int MAXK = 100000;
	final int MAXL = 1000000000;
	final int MAXDH = 1000000000;
	
	private void solve() throws IOException {
		int k = in.nextInt();
		assert MINK <= k && k <= MAXK;
		long[] l = new long[k];
		for (int i = 0; i < k; ++i) {
			l[i] = in.nextInt();
			assert 1 <= l[i] && l[i] <= MAXL;
		}
		long[] h = new long[k];
		for (int i = 1; i < k; ++i) {
			long th = in.nextInt();
			assert Math.abs(th) <= MAXDH;
			h[i] = h[i - 1] - th;
		}
		Arrays.sort(h);
		int m = in.nextInt();
		while (m --> 0) {
			int a = in.nextInt() - 1;
			int b = in.nextInt() - 1;
			out.println(l[a] + l[b] + Math.abs(h[a] - h[b]));
		}
	}
	
	final String FILE_NAME = "firtree";

	SimpleScanner in;
	PrintWriter out;

	@Override
	public void run() {
		try {
			in = new SimpleScanner(new FileReader(FILE_NAME + ".in"));
			out = new PrintWriter(FILE_NAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	public static void main(String[] args) {
		new Thread(new firtree_ab()).start();
	}

	class SimpleScanner extends BufferedReader {

		private StringTokenizer st;
		private boolean eof;

		public SimpleScanner(Reader a) {
			super(a);
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(readLine());
				} catch (Exception e) {
					eof = true;
					return "";
				}
			}
			return st.nextToken();
		}

		boolean seekEof() {
			String s = next();
			if ("".equals(s) && eof)
				return true;
			st = new StringTokenizer(s + " " + st.toString());
			return false;
		}

		private String cnv(String s) {
			if (s.length() == 0)
				return "0";
			return s;
		}

		int nextInt() {
			return Integer.parseInt(cnv(next()));
		}

		double nextDouble() {
			return Double.parseDouble(cnv(next()));
		}

		long nextLong() {
			return Long.parseLong(cnv(next()));
		}
	}
}